////////////////////////////////////////////////////////
// Aufgabe 6 aus Kapitel Räumliche Strukturen
//////////////////////////////////////////////////////// 
PImage texW, texT;
 
void setup()  { 
  size(800, 800, P3D); 
 // noStroke();
  stroke(0,50);
  strokeWeight(0.02);
  texW = loadImage("wuerfeltextur.jpg");
  texT = loadImage("tischtextur.png");
  textureMode(IMAGE);

} 
 
void draw() {
  background(255);
  translate(width / 2, height / 2);
  // rotiere um x-Achse je nach Höhe der Maus
  rotateX(- mouseY/float(height/2) * TWO_PI); 
  // rotiere um y-Achse je nach seitlicher Koordinate der Maus
  rotateY(- mouseX/float(width/2) * TWO_PI);   
  boxTextured(50,texW);//Würfel
  // Tischplatte
  tableTextured(texT);
 
}

void boxTextured(float scalef, PImage texB) {
  scale(scalef,scalef,scalef);
 
  beginShape(QUADS);
  texture(texB);
  
  // +Z Richtung, frontale Fläche
  
  vertex(-1, -1,  1, 0, 302); 
  vertex( 1, -1,  1, 300, 302);
  vertex( 1,  1,  1, 300, 602);
  vertex(-1,  1,  1, 0, 602);

  // -Z Richtung, hintere Fläche
  vertex( 1, -1, -1, 600, 302);
  vertex(-1, -1, -1, 900, 302);
  vertex(-1,  1, -1, 900, 602);
  vertex( 1,  1, -1, 600, 602);
  
   // +Y Richtung, untere Fläche
  vertex(-1,  1,  1, 300, 302);
  vertex( 1,  1,  1, 600, 302);
  vertex( 1,  1, -1, 600, 602);
  vertex(-1,  1, -1, 300, 602);

  
  // -Y Richtung, obere Fläche
  vertex(-1, -1, -1, 900, 302);
  vertex( 1, -1, -1, 1200, 302);
  vertex( 1, -1,  1, 1200, 602);
  vertex(-1, -1,  1, 900, 602);

  // +X Richtung, rechte Fläche
  vertex( 1, -1,  1, 600, 602);
  vertex( 1, -1, -1, 900, 602);
  vertex( 1,  1, -1, 900, 902);
  vertex( 1,  1,  1, 600, 902);

  // -X Richtung, linke Fläche
  vertex(-1, -1, -1, 600, 2);
  vertex(-1, -1,  1, 900, 2);
  vertex(-1,  1,  1, 900, 302);
  vertex(-1,  1, -1, 600, 302);

  endShape();
}

void tableTextured(PImage tex) {
  
  beginShape(QUADS);
  texture(tex);
  
 // -Y Richtung, obere Fläche
  vertex(-6, 1, -6,   0,   0);
  vertex( 6, 1, -6, 400,   0);
  vertex( 6, 1,  6, 400, 400);
  vertex(-6, 1,  6,   0, 400);
  
  // +Y Richtung, untere Fläche
  vertex(-6, 1.5, -6,   0,   0);
  vertex( 6, 1.5, -6, 400,   0);
  vertex( 6, 1.5,  6, 400, 400);
  vertex(-6, 1.5,  6,   0, 400);
  
  // +Z Richtung, frontale Fläche
  vertex(-6,   1, 6,  0,    0); 
  vertex( 6,   1, 6, 400,   0);
  vertex( 6, 1.5, 6,   0, 400);
  vertex(-6, 1.5, 6, 400, 400);
  
   // -Z Richtung, hintere Fläche
  vertex(-6,   1, -6,  0,    0); 
  vertex( 6,   1, -6, 400,   0);
  vertex( 6, 1.5, -6,   0, 400);
  vertex(-6, 1.5, -6, 400, 400);
  
  // +X Richtung, rechte Fläche
  vertex( 6,   1, -6,  0,    0); 
  vertex( 6,   1,  6, 400,   0);
  vertex( 6, 1.5,  6,   0, 400);
  vertex( 6, 1.5, -6, 400, 400);
  
  // -X Richtung, linke Fläche
  vertex(-6,   1, -6,  0,    0); 
  vertex(-6,   1,  6, 400,   0);
  vertex(-6, 1.5,  6,   0, 400);
  vertex(-6, 1.5, -6, 400, 400);
 

  endShape();
}